/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

#ifndef EXP4_DEBUG_H
#define EXP4_DEBUG_H


/* the default file for the debug messages */
#ifndef DEBUG_FILE
#define DEBUG_FILE stdout
#endif

/* the default debug level */
#ifndef DEBUG
#define DEBUG 0
#endif

/* overwrite the debug level given from the Makefile */
#ifdef LOCAL_DEBUG_LEVEL
#undef DEBUG
#define DEBUG LOCAL_DEBUG_LEVEL
#endif

/* the default debug level offset */
#ifndef LOCAL_DEBUG_OFFSET
#define LOCAL_DEBUG_OFFSET 0
#endif

/* if exp4 is used from the matlab cmex driver include the stats flag */
#ifdef MEX
extern int __Exp4MexDriverStats;
#undef DEBUG_FILE
#define DEBUG_FILE stdout
#include "mex.h"
#endif

#ifdef MEX
#define Exp4Message1(Args)						      \
if (__Exp4MexDriverStats > LOCAL_DEBUG_OFFSET)				      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG > LOCAL_DEBUG_OFFSET)
#define Exp4Message1(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message1(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message2(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET + 1))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+1,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 1)
#define Exp4Message2(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+1,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message2(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message3(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+2))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+2,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 2)
#define Exp4Message3(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+2,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message3(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message4(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+3))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+3,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 3)
#define Exp4Message4(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+3,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message4(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message5(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+4))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+4,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 4)
#define Exp4Message5(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+4,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message5(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message6(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+5))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+5,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 5)
#define Exp4Message6(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+5,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message6(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message7(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+6))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+6,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 6)
#define Exp4Message7(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+6,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message7(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message8(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+7))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+7,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 7)
#define Exp4Message8(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+7,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message8(Args) (void)0
#endif
#endif

#ifdef MEX
#define Exp4Message9(Args)						      \
if (__Exp4MexDriverStats > (LOCAL_DEBUG_OFFSET+8))			      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+8,"");			      \
  fprintf Args ;							      \
}
#else
#if (DEBUG - LOCAL_DEBUG_OFFSET > 8)
#define Exp4Message9(Args)						      \
{									      \
  fprintf(DEBUG_FILE,"%*s",LOCAL_DEBUG_OFFSET+8,"");			      \
  fprintf Args ;							      \
}
#else
#define Exp4Message9(Args) (void)0
#endif
#endif


/*
 * This is only for debugging purpose and therefore
 * it is enough to work with gcc
 */
#ifdef CASSERT
#undef CASSERT
#endif
#ifdef __GNUC__
#define CASSERT(cond,message,stopflag)					      \
if (cond) {								      \
  printf("%s: Function %s at line %d\n\t",				      \
	__FILE__, __FUNCTION__, __LINE__);				      \
  printf message;							      \
  fputc('\n',stdout);							      \
  if (stopflag) {							      \
    fflush(stdout);							      \
    fflush(stderr);							      \
    getchar();								      \
  }									      \
}
#else
#define CASSERT(a,b,c) (void)0
#endif

#endif
