/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

/* Does the internal exp4 error handling */

#include <stdlib.h>
#include <stdio.h>
#include <setjmp.h>
#include <stdarg.h>

#include "errors.h"
#include "debug.h"

static jmp_buf *Exp4ErrorExitJmpBuf = NULL;

void Exp4SetJumpBuf(jmp_buf *in)
{
  Exp4ErrorExitJmpBuf = in;
}

void Exp4ErrorReturnCall (char *comment,int value,char *file,int line, ...)
{
  va_list args;
  char errstring[4*81];
  jmp_buf *TmpBuf = Exp4ErrorExitJmpBuf;

  va_start(args,line);
  /* add the standard message */
  sprintf(errstring,"Exp4 Error, occured in source file %s at line %d:\n%s\n",
	file,line,comment);
  /* print to stderr */
  vfprintf(stderr,errstring,args);
  va_end(args);

  if (TmpBuf == NULL)
  {
    fprintf(stderr,"Fatal Exp4 error handling error:\nYou seem to call parts"
	  " of the Exp4 environment functions without calling Exp4!\n"
	  "So don't do that ...\nexit ...\n");
    exit(0);
  }

  Exp4ErrorExitJmpBuf = NULL;
  longjmp(*TmpBuf,value);
}

void Exp4LongJumpExit (int ret)
{
  jmp_buf *TmpBuf = Exp4ErrorExitJmpBuf;
  Exp4ErrorExitJmpBuf = NULL;
  if (TmpBuf == NULL)
  {
    fprintf(stderr,"Fatal Exp4 error handling error:\nYou seem to call parts"
	  " of the Exp4 environment functions without calling Exp4!\n"
	  "So don't do that ...\nexit ...\n");
    exit(0);
  }
  longjmp(*TmpBuf,ret);
}
