/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <math.h>
#include "ftypes.h"
#include "work.h"
#include "exp4.h"
#include "errors.h"

/* #define LOCAL_DEBUG_LEVEL 3 */
#define LOCAL_DEBUG_OFFSET 20
#include "debug.h"

#include "history.h"

History *InitHistory(int Length)
{
  History *Hist = Exp4GetWorkPointer(sizeof(History));
  Hist->Length = max(Length,1);
  Hist->Data = Exp4GetWorkPointer(Hist->Length*sizeof(*Hist->Data));
  Hist->Position = 0;
  Hist->Data[0] = 0;
  return Hist;
}

void AppendToHistory(History *Hist,finteger Value)
{
  Hist->Position++;
  Hist->Data[Hist->Position%Hist->Length] = Value;
}

void CopyLastEntry(History *Hist)
{
  int Help = Hist->Data[Hist->Position%Hist->Length];
  Hist->Position++;
  Hist->Data[Hist->Position%Hist->Length] = Help;
}

finteger GetMaximalHistoryEntry(History *Hist)
{
  finteger Help = 0;
  int i;
  int To = min(Hist->Length,Hist->Position+1);
  for (i = 0;i < To;i++)
    if (Help < Hist->Data[i]) Help = Hist->Data[i];

  return Help;
}

finteger GetHistoryEntry(History *Hist,int Number)
{
  int Help = Hist->Position + (Number);
  if (Help >= 0)
    return Hist->Data[Help%Hist->Length];
  else
    return INT_MAX;
}
