/*************************************************************************/
/* Copyright (C) 1995-1997 Marlis Hochbruck, Christian Lubich, Hubert    */
/* Selhofer. All rights reserved.                                        */
/*                                                                       */
/* C code written by Mathias Froehlich.                                  */
/*                                                                       */
/* This code is part of a copyrighted package. For details, see the file */
/* "COPYING" in the top-level directory.                                 */
/*************************************************************************/

#include <stdlib.h>
#include "ftypes.h"
#include "fblas.h"
#include "prec.h"
#include "exp4.h"
#include "errors.h"
#include "debug.h"

#include "work.h"
#include "ucalls.h"

static Complex *k;
static finteger ldk;
static finteger neq;
static Complex *Y;
static Exp4Boolean AllowReuse = Exp4True;
static int JacobianLifeTime = 15;


void PREC(Exp4SetJacobianLifeTime) (int Val)
{
  JacobianLifeTime = Val; 
}

int PREC(Exp4GetJacobianLifeTime) (void)
{
  return JacobianLifeTime;
}

void PREC(Exp4InitUcalls) (Complex *kIn,finteger ldkIn,
      Complex *YIn,finteger neqIn)
{
  k = kIn;
  ldk = ldkIn;
  Y = YIn;
  neq = neqIn;
}


Complex *PREC(Exp4GetInternalStep) (int i)
     /* Returns the pointer to the i-th internal step of the method.
	(1 <= i <= 7) */
{
  if ((0 < i) || (i < 8))
    return &k[(i-1)*ldk];
  else
    return NULL;
}

Complex *PREC(Exp4GetY) ()
     /* Returns the pointer to the vector which containes the actual y value */
{
  return Y;
}

void PREC(Exp4EnableReuse)(Exp4Boolean AllowIn)
{
  AllowReuse = AllowIn;
}

int PREC(Exp4AllowReuse)()
{
  return AllowReuse;
}
